include	dir.inc
include	dos.inc
include	string.inc

extrn	cp_stdmask: byte

ATTRIB_ALL	equ 0B7h ;37h
ATTRIB_FILE	equ 0F7h ;27h

	.data
	fp_maskp	dd ?
	fp_directory	p? ?
	fp_fileblock	p? ?
	scan_fblock	S_WFBLK <?>
	scan_curpath	db WMAXPATH dup(?)
	scan_curfile	db WMAXPATH dup(?)

	public	fp_maskp
	public	fp_directory
	public	fp_fileblock
	public	scan_fblock

	.code

ifndef	__f__

scan_init:
	mov [bp-12],dx
	mov [bp-10],ds
	mov word ptr [bp-8],offset scan_fblock
	mov [bp-6],ds
	xor ax,ax
	mov [bp-4],ax
	mov [bp-16],ax
      ifdef __LFN__
	cmp _ifsmgr,al
	jne @F
      endif
	mov ah,2Fh
	int 21h
	mov [bp-16],es
	mov [bp-14],bx
	lea dx,[bp-62]
	mov ah,1Ah
	int 21h
      @@:
	ret

scan_findfirst:
	mov dx,[bp-12]
      ifdef __LFN__
	.if _ifsmgr
	    mov ax,714Eh
	    mov si,1
	    les di,[bp-8]
	    stc
	    int 21h
	    jc scan_error
	    ret
	.endif
      endif
	mov ah,4Eh
	int 21h
	jnc scan_copy
	call restore_DTA
scan_error:
	call osmaperr
	cwd
	ret

scan_findnext:
      ifdef __LFN__
	.if _ifsmgr
	    stc
	    mov ax,714Fh
	    mov bx,[bp-18]
	    mov si,1
	    les di,[bp-8]
	    int 21h
	    jnc @F
	    cmp ax,0057h
	    jne scan_error
	    mov ax,714Fh
	    int 21h
	    jc scan_error
	  @@:
	    sub ax,ax
	    ret
	.endif
      endif
	mov ah,4Fh
	int 21h
	jc  scan_error
	jmp scan_copy

scan_close:
      ifdef __LFN__
	.if _ifsmgr
	    mov bx,[bp-18]
	    mov ax,71A1h
	    int 21h
	    ret
	.endif
      endif

restore_DTA:
	mov	ax,[bp-16]
	test	ax,ax
	jz	@F
	push	ds
	mov	ds,ax
	mov	dx,[bp-14]
	mov	ah,1Ah
	int	21h
	pop	ds
      @@:
	ret

scan_copy:
	push	si
	les	di,[bp-8]
	mov	si,di
	mov	cx,SIZE S_WFBLK/2
	xor	ax,ax
	cld?
	rep	stosw
	mov	di,si
	lea	si,[bp-62]
	mov	al,[si].S_FFBLK.ff_attrib
	mov	[di],al
	movmx	[di].S_WFBLK.wf_time,[si].S_FFBLK.ff_ftime
	movmx	[di].S_WFBLK.wf_sizeax,[si].S_FFBLK.ff_fsize
	add	si,S_FFBLK.ff_name
	add	di,S_WFBLK.wf_name
	mov	cx,6
	rep	movsw
	mov	ax,cx
	stosb
	pop	si
	ret

scan_directory proc _CType public uses ds si di flag:word, path:ptr byte
local locsp_d[62]:byte
	mov dx,offset scan_curpath
	call scan_init
	.if byte ptr flag & 1
	    pushm path
	    call fp_directory
	    mov [bp-4],ax
	    .if ax
		call restore_DTA
		jmp @F
	    .endif
	.endif
	invoke strlen,path
	add ax,offset scan_curpath
	mov [bp-2],ax
	invoke strfcat,[bp-12],path,addr cp_stdmask
	mov cx,ATTRIB_ALL
	call scan_findfirst
	.if ax != -1
	   mov [bp-18],ax
	   call scan_findnext
	   .if !ax
		.repeat
		    call scan_findnext
		    .break .if ax
		    .continue .if !(byte ptr scan_fblock & _A_SUBDIR)
		    mov  ax,[bp-2]
		    inc  ax
		    push ds
		    push ax
		    push [bp-6]
		    mov  ax,[bp-8]
		    add  ax,S_WFBLK.wf_name
		    push ax
		    call strcpy
		    invoke scan_directory,flag,[bp-12]
		    mov [bp-4],ax
		.until ax
	   .endif
	   call scan_close
	.endif
	xor ax,ax
	mov bx,[bp-2]
	mov [bx],al
      @@:
	mov ax,[bp-4]
	.if !(byte ptr flag & 1)
	    pushm path
	    call fp_directory
	.endif
	ret
scan_directory endp

scan_files proc _CType public uses ds si di fpath:ptr byte
local locsp_f[62]:byte
	mov dx,offset scan_curfile
	call scan_init
	invoke strfcat,[bp-12],fpath,fp_maskp
	mov cx,ATTRIB_FILE
	call scan_findfirst
	.if ax != -1
	    mov [bp-18],ax
	    .repeat
		.if !(byte ptr scan_fblock & _A_SUBDIR)
		    pushm fpath
		    pushm [bp-8]
		    call fp_fileblock
		    mov [bp-4],ax
		    .break .if ax
		.endif
		call scan_findnext
	    .until ax
	    call scan_close
	.endif
	mov ax,[bp-4]
	ret
scan_files endp

else

scan_directory proc _CType uses esi edi ebx flag:dword, directory:ptr byte
	sub edi,edi
	.if byte ptr flag & 1	; Call first
	    push directory
	    call fp_directory
	    mov edi,eax
	    .if eax
		jmp @F
	    .endif
	.endif
	invoke strlen,directory
	add eax,offset scan_curpath
	mov ebx,eax
	invoke strfcat,addr scan_curpath,directory,addr cp_stdmask
	invoke wfindfirst,addr scan_curpath,addr scan_fblock,ATTRIB_ALL
	.if eax != -1
	    mov esi,eax
	    .if !wfindnext(addr scan_fblock,esi)
	    	.repeat
		    invoke wfindnext,addr scan_fblock,esi
		    .break .if eax
		    .continue .if !(scan_fblock.wf_attrib & _A_SUBDIR)
		    mov ecx,ebx
		    inc ecx
		    invoke strcpy,ecx,addr scan_fblock.wf_name
		    invoke scan_directory,flag,addr scan_curpath
		    mov edi,eax
	    	.until eax
	    .endif
	    invoke wcloseff,esi
	    mov byte ptr [ebx],0
	.endif
      @@:
	mov eax,edi
	.if !eax && !(byte ptr flag & 1)
	    push directory
	    call fp_directory
	.endif
	ret
scan_directory endp

scan_files proc _CType uses esi edi directory:ptr byte
	sub edi,edi
	invoke strfcat,addr scan_curfile,directory,fp_maskp
	.if wfindfirst(addr scan_curfile,addr scan_fblock,ATTRIB_FILE) != -1
	    mov esi,eax
if 0
	    .if scan_fblock.wf_name == '.' && scan_fblock.wf_name[1] == 0
		.if wfindnext(addr scan_fblock,esi)
		    jmp @F
		.endif
		.if scan_fblock.wf_name == '.' && scan_fblock.wf_name[2] == 0
		    .if wfindnext(addr scan_fblock,esi)
			jmp @F
		    .endif
		.endif
	    .endif
endif
	    .repeat
		.if !(byte ptr scan_fblock & _A_SUBDIR)
		  ifdef __CDECL__
		    push offset scan_fblock
		    push directory
		  else
		    push directory
		    push offset scan_fblock
		  endif
		    call fp_fileblock
		    mov edi,eax
		    .break .if eax
		.endif
		invoke wfindnext,addr scan_fblock,esi
	    .until eax
	  @@:
	    invoke wcloseff,esi
	.endif
	mov eax,edi
	ret
scan_files endp

endif

scansub proc _CType public directory:dword, smask:dword, sflag:size_t
	movmx	fp_maskp,smask
	invoke	scan_directory,sflag,directory
	ret
scansub endp

	end
